<template>
  <v-dialog
    :value="value"
    max-width="500px"
    @input="$emit('input')"
    @click:outside="$emit('input')"
  >
    <v-card>
      <form id="form" v-on:submit.prevent="save">
        <v-card-title>
          <span> {{ isNewTask ? "New task" : "Edit task" }}</span>
        </v-card-title>
        <v-card-text>
          <v-text-field label="Title*" v-model="title"></v-text-field>
          <v-textarea
            name="input-7-4"
            label="Description"
            v-model="description"
            rows="2"
          ></v-textarea>
        </v-card-text>
        <v-card-actions>
          <v-btn color="primary" text v-on:click="$emit('input')">
            Close
          </v-btn>
          <v-btn
            color="primary"
            type="submit"
            text
            :disabled="!validation.title"
          >
            Save
          </v-btn>
        </v-card-actions>
      </form>
    </v-card>
  </v-dialog>
</template>

<script>
export default {
  name: "DialogTask",
  props: {
    value: null,
    isNewTask: Boolean,
    task: {
      type: Object,
      default() {
        return {
          id: -1,
          title: "",
          description: "",
          done: false,
        };
      },
    },
  },
  data: () => ({
    title: "",
    description: "",
  }),
  created() {
    this.title = this.task.title;
    this.description = this.task.description;
  },
  methods: {
    save() {
      if (this.isValid) {
        let taskAux = {
          id: this.task.id,
          title: this.title,
          description: this.description,
          done: this.task.done,
        };
        if (this.isNewTask) this.$emit("add", taskAux);
        else this.$emit("edit", taskAux);
        this.$emit("input");
      }
    },
  },
  computed: {
    validation: function () {
      return {
        title: !!this.title.trim(),
      };
    },
    isValid: function () {
      var validation = this.validation;
      return Object.keys(validation).every(function (key) {
        return validation[key];
      });
    },
  },
};
</script>